﻿using SyncFusionDemo1.Interfaces.Services;
using System;
using System.Collections.Generic;
using System.Text;

namespace SyncFusionDemo1.ViewModels.Pages
{
    public abstract class ComboBoxNavigationViewModel : BasePageViewModel
    {
        protected readonly INavigationService _navigationService;

        private ComboOptionViewModel _currentPage;

        public string NavigationTitle { get; } = "Sample";

        public List<ComboOptionViewModel> ComboBoxPages { get; } = new List<ComboOptionViewModel>();

        public ComboOptionViewModel CurrentPage
        {
            get { return _currentPage; }
            set
            {
                bool notFirstSet = (_currentPage != null);

                if (_currentPage != value)
                {
                    _currentPage = value;

                    if (notFirstSet)
                    {
                        var typeValue = value.VMType;
                        _navigationService.ShowPageAsync(typeValue);
                    }
                }
            }
        }

        public ComboBoxNavigationViewModel(INavigationService navigationService)
        {
            _navigationService = navigationService;

            ComboBoxPages.Add(new ComboOptionViewModel("Page 1", typeof(Page1ViewModel)));
            ComboBoxPages.Add(new ComboOptionViewModel("Page 2", typeof(Page2ViewModel)));

        }
    }
}